local addonName = ...
local core = LibStub("AceAddon-3.0"):NewAddon(addonName, "AceEvent-3.0", "AceConsole-3.0", "AceTimer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale(addonName)

core.factions = {}
core.gainsReputation = {}
core.timerReputation = false

core.currencies = nil
core.gainsCurrency = {}
core.timerCurrency = false

core.defaultColors = FACTION_BAR_COLORS
core.prettyColors = {
   [1] = {r = 0.63, g = 0.00, b = 0.00}, -- Hated
   [2] = {r = 0.63, g = 0.00, b = 0.00}, -- Hostile
   [3] = {r = 0.63, g = 0.00, b = 0.00}, -- Unfriendly
   [4] = {r = 0.82, g = 0.67, b = 0.00}, -- Neutral
   [5] = {r = 0.50, g = 0.74, b = 0.43}, -- Friendly
   [6] = {r = 0.49, g = 0.73, b = 0.42}, -- Honored
   [7] = {r = 0.47, g = 0.68, b = 0.47}, -- Revered
   [8] = {r = 0.40, g = 0.62, b = 0.40}, -- Exalted
}

core.defaults = {
   profile  = {
      delay = 0.5,

      reputationReplace = true,
      colors = true,
      changeReputationBar = true,

      currencyReplace = true,

   }
}


local factionsList = {
   21, -- Booty Bay
   47, -- Ironforge
   54, -- Gnomeregan
   59, -- Thorium Brotherhood
   68, -- Undercity
   69, -- Darnassus
   70, -- Syndicate
   72, -- Stormwind
   76, -- Orgrimmar
   81, -- Thunder Bluff
   87, -- Bloodsail Buccaneers
   92, -- Gelkis Clan Centaur
   93, -- Magram Clan Centaur
   270, -- Zandalar Tribe
   349, -- Ravenholdt
   369, -- Gadgetzan
   470, -- Ratchet
   509, -- The League of Arathor
   510, -- The Defilers
   529, -- Argent Dawn
   530, -- Darkspear Trolls
   576, -- Timbermaw Hold
   577, -- Everlook
   589, -- Wintersaber Trainers
   609, -- Cenarion Circle
   729, -- Frostwolf Clan
   730, -- Stormpike Guard
   749, -- Hydraxian Waterlords
   809, -- Shen'dralar
   889, -- Warsong Outriders
   890, -- Silverwing Sentinels
   909, -- Darkmoon Faire
   910, -- Brood of Nozdormu
   911, -- Silvermoon City
   922, -- Tranquillien
   930, -- Exodar
   932, -- The Aldor
   933, -- The Consortium
   934, -- The Scryers
   935, -- The Sha'tar
   941, -- The Mag'har
   942, -- Cenarion Expedition
   946, -- Honor Hold
   947, -- Thrallmar
   967, -- The Violet Eye
   970, -- Sporeggar
   978, -- Kurenai
   989, -- Keepers of Time
   990, -- The Scale of the Sands
   1011, -- Lower City
   1012, -- Ashtongue Deathsworn
   1015, -- Netherwing
   1031, -- Sha'tari Skyguard
   1037, -- Alliance Vanguard
   1038, -- Ogri'la
   1050, -- Valiance Expedition
   1052, -- Horde Expedition
   1064, -- The Taunka
   1067, -- The Hand of Vengeance
   1068, -- Explorers' League
   1073, -- The Kalu'ak
   1077, -- Shattered Sun Offensive
   1085, -- Warsong Offensive
   1090, -- Kirin Tor
   1091, -- The Wyrmrest Accord
   1094, -- The Silver Covenant
   1098, -- Knights of the Ebon Blade
   1104, -- Frenzyheart Tribe
   1105, -- The Oracles
   1106, -- Argent Crusade
   1119, -- The Sons of Hodir
   1124, -- The Sunreavers
   1126, -- The Frostborn
   1133, -- Bilgewater Cartel
   1134, -- Gilneas
   1135, -- The Earthen Ring
   1156, -- The Ashen Verdict
   1158, -- Guardians of Hyjal
   1168, -- Guild
   1171, -- Therazane
   1172, -- Dragonmaw Clan
   1173, -- Ramkahen
   1174, -- Wildhammer Clan
   1177, -- Baradin's Wardens
   1178, -- Hellscream's Reach
   1204, -- Avengers of Hyjal
   1216, -- Shang Xi's Academy
   1228, -- Forest Hozen
   1242, -- Pearlfin Jinyu
   1269, -- Golden Lotus
   1270, -- Shado-Pan
   1271, -- Order of the Cloud Serpent
   1272, -- The Tillers
   1273, -- Jogu the Drunk
   1275, -- Ella
   1276, -- Old Hillpaw
   1277, -- Chee Chee
   1278, -- Sho
   1279, -- Haohan Mudclaw
   1280, -- Tina Mudclaw
   1281, -- Gina Mudclaw
   1282, -- Fish Fellreed
   1283, -- Farmer Fung
   1302, -- The Anglers
   1337, -- The Klaxxi
   1341, -- The August Celestials
   1345, -- The Lorewalkers
   1351, -- The Brewmasters
   1352, -- Huojin Pandaren
   1353, -- Tushui Pandaren
   1357, -- Nomi
   1358, -- Nat Pagle
   1359, -- The Black Prince
   1374, -- Brawl'gar Arena (Season 1)
   1375, -- Dominance Offensive
   1376, -- Operation: Shieldwall
   1387, -- Kirin Tor Offensive
   1388, -- Sunreaver Onslaught
   1419, -- Bizmo's Brawlpub (Season 1)
   1435, -- Shado-Pan Assault
   1440, -- Darkspear Rebellion
   1445, -- Frostwolf Orcs
   1492, -- Emperor Shaohao
   1515, -- Arakkoa Outcasts
   1520, -- Shadowmoon Exiles
   1681, -- Vol'jin's Spear
   1682, -- Wrynn's Vanguard
   1690, -- Brawl'gar Arena (Season 2)
   1691, -- Bizmo's Brawlpub (Season 2)
   1708, -- Laughing Skull Orcs
   1710, -- Sha'tari Defense
   1711, -- Steamwheedle Preservation Society
   1731, -- Council of Exarchs
   1732, -- Steamwheedle Draenor Expedition
   1733, -- Delvar Ironfist
   1735, -- Barracks Bodyguards
   1736, -- Tormmok
   1737, -- Talonpriest Ishaal
   1738, -- Defender Illona
   1739, -- Vivianne
   1740, -- Aeda Brightdawn
   1741, -- Leorajh
   1815, -- Gilnean Survivors
   1828, -- Highmountain Tribe
   1847, -- Hand of the Prophet
   1848, -- Vol'jin's Headhunters
   1849, -- Order of the Awakened
   1850, -- The Saberstalkers
   1859, -- The Nightfallen
   1860, -- Arcane Thirst (Thalyssra)
   1861, -- Arcane Thirst (Silgryn) DEPRECATED
   1862, -- Arcane Thirst (Oculeth)
   1883, -- Dreamweavers
   1888, -- Jandvik Vrykul
   1894, -- The Wardens
   1899, -- Moonguard
   1900, -- Court of Farondis
   1919, -- Arcane Thirst (Valtrois)
   1947, -- Illidari
   1948, -- Valarjar
   1975, -- Conjurer Margoss
   1984, -- The First Responders
   1989, -- Moon Guard
   2010, -- Brawl'gar Arena
   2011, -- Bizmo's Brawlpub
   2018, -- Talon's Vengeance
   2045, -- Armies of Legionfall
   2062, -- Arne Test - Paragon Reputation
   2063, -- Arne Test - Paragon Reputation Stormwind
   2085, -- Highmountain Tribe (Paragon)
   2086, -- Valarjar (Paragon)
   2087, -- Court of Farondis (Paragon)
   2088, -- Dreamweavers (Paragon)
   2089, -- The Nightfallen (Paragon)
   2090, -- The Wardens (Paragon)
   2091, -- Armies of Legionfall (Paragon)
   2097, -- Ilyssia of the Waters
   2098, -- Keeper Raynae
   2099, -- Akule Riverhorn
   2100, -- Corbyn
   2101, -- Sha'leth
   2102, -- Impus
}

local currenciesList = {
   61, -- Dalaran Jewelcrafter's Token
   81, -- Epicurean's Award
   241, -- Champion's Seal
   361, -- Illustrious Jewelcrafter's Token
   384, -- Dwarf Archaeology Fragment
   385, -- Troll Archaeology Fragment
   391, -- Tol Barad Commendation
   393, -- Fossil Archaeology Fragment
   394, -- Night Elf Archaeology Fragment
   397, -- Orc Archaeology Fragment
   398, -- Draenei Archaeology Fragment
   399, -- Vrykul Archaeology Fragment
   400, -- Nerubian Archaeology Fragment
   401, -- Tol'vir Archaeology Fragment
   402, -- Ironpaw Token
   416, -- Mark of the World Tree
   515, -- Darkmoon Prize Ticket
   614, -- Mote of Darkness
   615, -- Essence of Corrupted Deathwing
   676, -- Pandaren Archaeology Fragment
   677, -- Mogu Archaeology Fragment
   697, -- Elder Charm of Good Fortune
   738, -- Lesser Charm of Good Fortune
   752, -- Mogu Rune of Fate
   754, -- Mantid Archaeology Fragment
   776, -- Warforged Seal
   777, -- Timeless Coin
   789, -- Bloody Coin
   821, -- Draenor Clans Archaeology Fragment
   823, -- Apexis Crystal
   824, -- Garrison Resources
   828, -- Ogre Archaeology Fragment
   829, -- Arakkoa Archaeology Fragment
   910, -- Secret of Draenor Alchemy
   944, -- Artifact Fragment
   980, -- Dingy Iron Coins
   994, -- Seal of Tempered Fate
   999, -- Secret of Draenor Tailoring
   1008, -- Secret of Draenor Jewelcrafting
   1017, -- Secret of Draenor Leatherworking
   1020, -- Secret of Draenor Blacksmithing
   1101, -- Oil
   1129, -- Seal of Inevitable Fate
   1149, -- Sightless Eye
   1154, -- Shadowy Coins
   1155, -- Ancient Mana
   1166, -- Timewarped Badge
   1171, -- Artifact Knowledge
   1172, -- Highborne Archaeology Fragment
   1173, -- Highmountain Tauren Archaeology Fragment
   1174, -- Demonic Archaeology Fragment
   1191, -- Valor
   1220, -- Order Resources
   1226, -- Nethershard
   1268, -- Timeworn Artifact
   1273, -- Seal of Broken Fate
   1275, -- Curious Coin
   1299, -- Brawler's Gold
   1314, -- Lingering Soul Fragment
   1324, -- Horde Qiraji Commendation
   1325, -- Alliance Qiraji Commendation
   1342, -- Legionfall War Supplies
   1347, -- Legionfall Building - Personal Tracker - Mage Tower (Hidden)
   1349, -- Legionfall Building - Personal Tracker - Command Tower (Hidden)
   1350, -- Legionfall Building - Personal Tracker - Nether Tower (Hidden)
   1355, -- Felessence
   1356, -- Echoes of Battle
   1357, -- Echoes of Domination
}




function core:OnInitialize()
   self.db = LibStub("AceDB-3.0"):New("TrackerDB", self.defaults, true)

   self:RegisterEvent("PLAYER_ENTERING_WORLD", "WorldEnter")
   self:RegisterEvent("ADDON_LOADED", "Loaded")

   self:RegisterEvent("CURRENCY_DISPLAY_UPDATE", "CurrenciesPreChanges")

   ChatFrame_AddMessageEventFilter("CHAT_MSG_COMBAT_FACTION_CHANGE", _ChatFilter)
   ChatFrame_AddMessageEventFilter("CHAT_MSG_CURRENCY", _ChatFilter)
end

function core:Loaded()
   self:UnregisterEvent("ADDON_LOADED")
   self:updateColors()
end

function core:WorldEnter()
   self:UnregisterEvent("PLAYER_ENTERING_WORLD")
   self.factions = self:GetFactions()
   self.currencies = self:GetCurrencies()


   for i = 1, 100 do
      local bar = _G["ReputationBar"..i]
      if bar ~= nil then
         if bar.tooltip ~= nil and bar.hasRep then
            local OnEnter = bar:GetScript("OnEnter")
            bar:SetScript("OnEnter", function(self)
               local
                  name,
                  description,
                  standingId,
                  barMin,
                  barMax,
                  barValue,
                  atWarWith,
                  canToggleAtWar,
                  isHeader,
                  isCollapsed,
                  hasRep,
                  isWatched,
                  isChild,
                  factionID,
                  hasBonusRepGain,
                  canBeLFGBonu
                     = GetFactionInfo(self.index)
               if self.standingText ~= nil and factionID ~= nil then
                  GameTooltip:SetOwner(self, "ANCHOR_BOTTOMRIGHT", 5, 20)
                  GameTooltip:SetText(name, 1, .82, 0, true)
                  GameTooltip:AddLine(self.standingText, 1, 1, 1, true)
                  currentAmount = barValue - barMin;
                  currentMax = barMax - barMin;
                  GameTooltip:AddLine(L["left"]:gsub("^%l", string.upper)..": "..(currentMax - currentAmount), 1, 1, 1, true)

                  GameTooltip:Show()
               end
               OnEnter(self)
            end)
            local OnLeave = bar:GetScript("OnLeave")
            bar:SetScript("OnLeave", function(self)
               GameTooltip:Hide()
               OnLeave(self)
            end)
         end
      end
   end
end

function core:updateColors()
   if self.db.profile.colors then
      FACTION_BAR_COLORS = self.prettyColors
   else
      FACTION_BAR_COLORS = self.defaultColors
   end
end

function _ChatFilter(self, event, msg, ...)
   local skip = false
   if event == "CHAT_MSG_COMBAT_FACTION_CHANGE" then
      if string.match(msg, "%d") == nil then
         -- matched paragon reputation
         skip = false
      else
         if core.db.profile.delay > 0 then
            if core.timerReputation ~= nil then
               core:CancelTimer(core.timerReputation)
            end
            core.timerReputation = core:ScheduleTimer("FactionsChanges", core.db.profile.delay)
         else
            core:FactionsChanges()
         end
         skip = core.db.profile.reputationReplace
      end
   elseif event == "CHAT_MSG_CURRENCY" then
      skip = core.db.profile.currencyReplace
   end
   return skip, msg, ...
end

function core:CurrenciesPreChanges()
   if self.db.profile.delay > 0 then
      if self.timerCurrency ~= nil then
         self:CancelTimer(self.timerCurrency)
      end
      self.timerCurrency = self:ScheduleTimer("CurrenciesChanges", self.db.profile.delay)
   else
      self:CurrenciesChanges()
   end
end

function core:FactionsChanges()
   local factions = self.GetFactions()
   local old = nil
   local diff = 0

   for i, new in pairs(factions) do
      if self.gainsReputation[i] == nil then
         self.gainsReputation[i] = 0
      end
      if self.factions[i] ~= nil then
         old = self.factions[i]
         diff = new.barValue - old.barValue
         if diff ~= 0 then
            self.gainsReputation[i] = self.gainsReputation[i] + diff
            self:PrintReputation(new, diff, false)
         end
      else
         self.gainsReputation[i] = new.barValue
         self:PrintReputation(new, new.barValue, true)
      end

   end
   self.factions = factions
end

function core:CurrenciesChanges()
   if self.currencies == nil then
      return
   end

   local currencies = self.GetCurrencies()
   local old = nil
   local diff = 0

   for i, new in pairs(currencies) do
      if self.gainsCurrency[i] == nil then
         self.gainsCurrency[i] = 0
      end
      if self.currencies[i] ~= nil then
         old = self.currencies[i]
         diff = new.currentAmount - old.currentAmount
         if diff ~= 0 then
            self.gainsCurrency[i] = self.gainsCurrency[i] + diff
            self:PrintCurrency(new, diff, false)
         end
      else
         self.gainsCurrency[i] = new.currentAmount
         self:PrintCurrency(new, new.currentAmount, true)
      end

   end
   self.currencies = currencies
end

function core:PrintReputation(new, diff, newFaction)
   local color = {
      main = "|cFF8080ff",
      off = "|cFFA7A7ff",
      points = "",
      gain = "|cFF40ff40",
      loss = "|cFFff4040"
   }

   local total = self.gainsReputation[new.factionID]

   if diff == 0 then
      return
   elseif diff > 0 then
      color.points = color.gain
   else
      color.points = color.loss
   end

   local str = color.main .. new.name .. ": " .. color.points .. diff .. " p." .. color.main

   if not newFaction then
      str = str .. color.off .. "  (" .. L["session"] .. ": " .. total .. ", " .. L["left"] .. ": "  .. new.currentNext .. " "  .. new.intervalNextName .. ")"
   end

   if core.db.profile.reputationReplace then
      self:_Print(str)
   end

   if self.db.profile.changeReputationBar then
      SetWatchedFactionIndex(new.index)
   end
end

function core:PrintCurrency(new, diff, newCurrency)
   local color = {
      main = "|cFF00aa00",
      off = "|cFF42cf42",
      points = "",
      gain = "|cFF40ff40",
      loss = "|cFFff4040"
   }

   local total = self.gainsCurrency[new.index]

   if diff == 0 then
      return
   elseif diff > 0 then
      color.points = color.main
   else
      color.points = color.loss
      diff =  0 - diff
   end

   local str = new.link .. color.main .. ": " .. color.points .. "x" .. diff .. "" .. color.main .. ". "


   str = str .. color.off .. "("

   str = str .. L["session"] .. ": " .. total .. ", "

   str = str .. L["total"] .. ": " .. new.currentAmount
   if new.totalMax > 0 then
      str = str .. "/" .. new.totalMax
   end

   str = str .. ")"

   -- if not newCurrency then
      -- str = str .. color.off .. "  (session: " .. total .. ", left: "  .. new.currentNext .. " "  .. new.intervalNextName .. ")"
   -- end

   if core.db.profile.currencyReplace then
      self:_Print(str)
   end
end

function core:GetFactions()
   local factions = {}

   for k,i in pairs(factionsList) do
      local
         name,
         description,
         standingId,
         barMin,
         barMax,
         barValue,
         atWarWith,
         canToggleAtWar,
         isHeader,
         isCollapsed,
         hasRep,
         isWatched,
         isChild,
         factionID,
         hasBonusRepGain,
         canBeLFGBonus
            = GetFactionInfoByID(i)

      if not isHeader and factionID ~= nil then



         if barValue == nil then
            barValue = 0;
         end

         local standingNextId = standingId + 1
         if standingNextId > 8 then standingNextId = 8 end
         standingName = _G["FACTION_STANDING_LABEL" .. standingId];
         standingNextName = _G["FACTION_STANDING_LABEL" .. standingNextId];

         currentAmount = barValue - barMin;
         currentMax = barMax - barMin;

         local faction = {
               factionID = factionID,
               index = i,
               name = name,

               intervalId = standingId,
               intervalName= standingName,
               intervalNextId = standingNextId,
               intervalNextName = standingNextName,

               current = currentAmount,
               currentMax = currentMax,
               currentNext = currentMax - currentAmount,

               barMin = barMin,
               barMax = barMax,
               barValue = barValue
            }

         factions[factionID] = faction

      end
   end

   return factions

end

function core:GetCurrencies()
   local currencies  = {};

   for k,i in pairs(currenciesList) do
      local name, currentAmount, texture, earnedThisWeek, weeklyMax, totalMax, isDiscovered, rarity = GetCurrencyInfo(i);

      if name ~= nil and isDiscovered then

         local currency = {
            index = i,
            name = name,
            texture = texture,
            link = GetCurrencyLink(i),
            rarity = rarity,

            currentAmount = currentAmount,

            weekAmount = earnedThisWeek,
            weeklMax = weeklyMax,

            totalMax = totalMax,

            isDiscovered = isDiscovered

         }
         currencies[i] = currency
      end
   end

   return currencies;
end

function core:_Print(...)
   DEFAULT_CHAT_FRAME:AddMessage(...)
end

function core:debug(tData)
   if ViragDevTool_AddData then
      ViragDevTool_AddData(tData, "debug")
   end
end